// JavaScript doesn't have actual constants or finals, but these things
// in all caps are constants and should never be changed in the code.

// The width and height here match what's specified in the #front in the CSS
var VISIBLE_AREA_WIDTH  = 295;
var VISIBLE_AREA_HEIGHT = 385;

var TEXT_AREA_BOTTOM = VISIBLE_AREA_HEIGHT - 26;
var RATINGS_KEY_HEIGHT = 12;
var MAX_URL_CHARS_PER_WIDTH = Math.floor(VISIBLE_AREA_WIDTH / 6);

var TIMEOUT_MILLIS = 50;

//var LEFT_DROP_DOWN_IMAGE_WIDTH  = 20;
//var RIGHT_DROP_DOWN_IMAGE_WIDTH = 20;
var DROP_DOWN_IMAGE_SIDES_WIDTH = 40;

var PIXELS_PER_CHAR = 6;

var ROW_HEIGHT = 14;

var MAX_MIDDLE_DROP_DOWN_WIDTH = VISIBLE_AREA_WIDTH - DROP_DOWN_IMAGE_SIDES_WIDTH;
var MAX_DROP_DOWN_CHARS = Math.floor(MAX_MIDDLE_DROP_DOWN_WIDTH / PIXELS_PER_CHAR) - 3;

var MID_INFO_HOFFSET = 136;

//var BASE_URL = "http://www.profster.com/";
var BASE_URL = "http://www.restaurantratingz.com/";

var WIDGET_STATE_LIST_JSP  = "local/widgetStateList.jsp";
var WIDGET_CITY_LIST_JSP   = "local/widgetCityList.jsp";
var WIDGET_REST_LIST_JSP   = "local/widgetRestList.jsp";
var WIDGET_RATING_INFO_JSP = "local/widgetRatingInfo.jsp";

var SHOW_RATINGS_JSP = "ShowRatings.jsp";
var ADD_RATING_JSP   = "AddRating.jsp";

var RATINGS_CAT_LABELS = new Array("Food", "Ambience", "Service");

var url = new URL();
var nextUrlString;
var delayedUrlTimer;

var statesMenu = new Array();
var citiesMenu = new Array();
var restaurantsMenu = new Array();
var maxCharsInMenu = 0;

var infoLabels = new Array();
var infoValues = new Array();

var htmlBrRegex = /<br>/gi


function loaded() {
    rateThisLink.data = "RATE THIS\nRESTAURANT";

    getStateList();

    statesLabel.hOffset = statesBackground.hOffset + 15;
    statesLabel.vOffset = statesBackground.vOffset + 13;

    citiesBackgroundLeft.hOffset = statesBackground.hOffset;
    citiesBackgroundLeft.vOffset = statesBackground.vOffset + statesBackground.height + 2;
    citiesBackgroundMiddle.hOffset = citiesBackgroundLeft.hOffset + citiesBackgroundLeft.width;
    citiesBackgroundMiddle.vOffset = citiesBackgroundLeft.vOffset;
    citiesBackgroundRight.vOffset = citiesBackgroundLeft.vOffset;

    citiesLabel.hOffset = citiesBackgroundLeft.hOffset + 15;
    citiesLabel.vOffset = citiesBackgroundLeft.vOffset + 13;

    restaurantsBackgroundLeft.hOffset = citiesBackgroundLeft.hOffset;
    restaurantsBackgroundLeft.vOffset = citiesBackgroundLeft.vOffset + citiesBackgroundLeft.height + 2;
    restaurantsBackgroundMiddle.hOffset = restaurantsBackgroundLeft.hOffset + restaurantsBackgroundLeft.width;
    restaurantsBackgroundMiddle.vOffset = restaurantsBackgroundLeft.vOffset;
    restaurantsBackgroundRight.vOffset = restaurantsBackgroundLeft.vOffset;

    restaurantsLabel.hOffset = restaurantsBackgroundLeft.hOffset + 15;
    restaurantsLabel.vOffset = restaurantsBackgroundLeft.vOffset + 13;

    pleaseWait.hOffset = (mainWindow.width / 2) - (pleaseWait.width / 2);
    pleaseWait.vOffset = ratingTableBkg.vOffset + 2;

    statesBackground.opacity = 255;
    statesLabel.opacity = 255;
}

function getStateList() {
    var stateListXml = url.fetch(BASE_URL + WIDGET_STATE_LIST_JSP);
    var parser = new DOMImplementation();
    var stateListDoc = parser.loadXML(stateListXml);

    buildSelectMenu(statesMenu, "Select your state", "state", stateListDoc, "getCityList");
}

function showStatesMenu() {
    popupMenu(statesMenu, statesLabel.hOffset - 15, statesLabel.vOffset - 15);
}

function getCityList(stateName, stateId) {

    statesLabel.data = stateName;

    hideCitiesSelect();
    citiesLabel.data = "Select a city";

    hideRestaurantSelect();
    clearRestaurantInfo(true);

    showWait();

    // The extra complexity here of using a timer rather than just
    // calling url.fetch directly, is needed to insert a slight delay
    // so that the window has time to update. Why don't I use url.fetchAsync?
    // Because for some unknown reason, when buildCitySelect() is called by that,
    // it doesn't work. No errors, all the code executes, but the window doesn't
    // get updated.
    //url.location = BASE_URL + WIDGET_CITY_LIST_JSP + "?tcvid=" + stateId + "&noredirect=1";
    //url.fetchAsync(buildCitySelect);
    nextUrlString = BASE_URL + WIDGET_CITY_LIST_JSP + "?tcvid=" + stateId + "&noredirect=1";
    delayedUrlTimer = new Timer();
    delayedUrlTimer.interval = 0.05;
    delayedUrlTimer.onTimerFired = "buildCitySelect()";
    delayedUrlTimer.ticking = true;
}

function buildCitySelect() {
try {
    delayedUrlTimer.ticking = false;
    delayedUrlTimer = null;
    url.clear();
    var cityListXml = url.fetch(nextUrlString);
    var parser = new DOMImplementation();
    var cityListDoc = parser.loadXML(cityListXml);

    buildSelectMenu(citiesMenu, "Select a city", "city", cityListDoc, "getRestaurantList");
    citiesBackgroundMiddle.width = maxCharsInMenu * PIXELS_PER_CHAR;
    citiesBackgroundRight.hOffset = citiesBackgroundMiddle.hOffset + citiesBackgroundMiddle.width;

    showCitiesSelect();
} catch (err) {
}

hideWait();
}

function showCitiesMenu() {
    popupMenu(citiesMenu, citiesLabel.hOffset - 15, citiesLabel.vOffset - 15);
}

function getRestaurantList(cityName, cityId) {

    citiesLabel.data = cityName;

    hideRestaurantSelect();

    restaurantsLabel.data = "Select a restaurant";

    clearRestaurantInfo(true);

    showWait();

    nextUrlString = BASE_URL + WIDGET_REST_LIST_JSP + "?tcvid=" + cityId + "&numrows=1000";
    delayedUrlTimer = new Timer();
    delayedUrlTimer.interval = 0.05;
    delayedUrlTimer.onTimerFired = "buildRestaurantSelect()";
    delayedUrlTimer.ticking = true;
}

function buildRestaurantSelect() {
try {
    delayedUrlTimer.ticking = false;
    delayedUrlTimer = null;
    url.clear();
    var restaurantListXml = url.fetch(nextUrlString);
    var parser = new DOMImplementation();
    var restaurantListDoc = parser.loadXML(restaurantListXml);

    buildSelectMenu(restaurantsMenu, "Select a restaurant", "restaurant", restaurantListDoc, "getRestaurantInfo");
    restaurantsBackgroundMiddle.width = maxCharsInMenu * PIXELS_PER_CHAR;
    restaurantsBackgroundRight.hOffset = restaurantsBackgroundMiddle.hOffset + restaurantsBackgroundMiddle.width;

    showRestaurantSelect();
} catch (err) {
}

hideWait();
}

function showRestaurantsMenu() {
    popupMenu(restaurantsMenu, restaurantsLabel.hOffset - 15, restaurantsLabel.vOffset - 15);
}

function hideCitiesSelect() {
    citiesBackgroundLeft.opacity = 0;
    citiesBackgroundMiddle.opacity = 0;
    citiesBackgroundRight.opacity = 0;
    citiesLabel.opacity = 0;
}

function showCitiesSelect() {
    citiesBackgroundLeft.opacity = 255;
    citiesBackgroundMiddle.opacity = 255;
    citiesBackgroundRight.opacity = 255;
    citiesLabel.opacity = 255;
}

function hideRestaurantSelect() {
    restaurantsBackgroundLeft.opacity = 0;
    restaurantsBackgroundMiddle.opacity = 0;
    restaurantsBackgroundRight.opacity = 0;
    restaurantsLabel.opacity = 0;
}

function showRestaurantSelect() {
    restaurantsBackgroundLeft.opacity = 255;
    restaurantsBackgroundMiddle.opacity = 255;
    restaurantsBackgroundRight.opacity = 255;
    restaurantsLabel.opacity = 255;
}

function clearRestaurantInfo(hideRatings) {
    var idx;

    if (hideRatings) {
        ratingTableBkg.opacity = 0;
        numRatingsLabel.opacity = 0;
        numRatings.opacity = 0;
        avgRatingLabel.opacity = 0;
        avgRating.opacity = 0;
        smileyImage.opacity = 0;
        rateThisLink.opacity = 0;
    }

    for (idx = 0; idx < infoLabels.length; idx++) {
        infoLabels[idx].removeFromSuperview();
        infoValues[idx].removeFromSuperview();
        delete infoLabels[idx];
        delete infoValues[idx];
    }
    infoLabels = new Array();
    infoValues = new Array();

    websiteUrlNode.opacity = 0;

    horizRule.opacity = 0;

    commentsFrame.opacity = 0;
    commentsScrollbar.opacity = 0;
    commentsScrollbar.value = 0;

    //hideScrollBar();
}

function clearSelectList(select) {
    while (select.length > 0) {
        select.pop();
    }
}

// Create and append a new MenuItem to the specified array.
// The content parameter is expected to be a string.
function appendToSelect(select, idAttr, content, onSelectFunc) {
    var opt = new MenuItem;
    opt.title = content;
    opt.enabled = true;
    if (onSelectFunc != null) {
        opt.onSelect = onSelectFunc + "('" + content.replace("'", "\\'") + "'," + idAttr + ");";
    }
    select.push(opt);

    var numChars = content.length;
    if (numChars > maxCharsInMenu) {
        maxCharsInMenu = numChars;
    }
}

function buildSelectMenu(selectMenu, firstLine, xmlElementName, xmlDoc, onSelectFunc) {
    maxCharsInMenu = 0;
    clearSelectList(selectMenu);
    appendToSelect(selectMenu, 0, firstLine, null);

    var elementList = xmlDoc.getElementsByTagName(xmlElementName);
    for (var idx = 0; idx < elementList.length; idx++) {
        var element = elementList.item(idx);
        var idAttr = element.getAttribute("id");
        var nameNode = element.getElementsByTagName("name").item(0);
        var nameText = nameNode.firstChild.nodeValue;
        appendToSelect(selectMenu, idAttr, nameText, onSelectFunc);
        //appendToSelect(select, idAttr, nameText + " " + idAttr);
    }

    if (maxCharsInMenu > MAX_DROP_DOWN_CHARS) {
        maxCharsInMenu = MAX_DROP_DOWN_CHARS;
    }
}

function clearTable(tableNode) {
    var oneRow = tableNode.getElementsByTagName("TR").item(0);
    while (oneRow != null) {
        tableNode.removeChild(oneRow);
        oneRow = tableNode.getElementsByTagName("TR").item(0);
    }
}

function getRestaurantInfo(restaurantName, restaurantId) {
    restaurantsLabel.data = restaurantName;

    showWait();

    nextUrlString = BASE_URL + WIDGET_RATING_INFO_JSP + "?tcvid=" + restaurantId + "&noredirect=1";
    delayedUrlTimer = new Timer();
    delayedUrlTimer.interval = 0.05;
    delayedUrlTimer.onTimerFired = "showRestaurantInfo()";
    delayedUrlTimer.ticking = true;
}

function showRestaurantInfo() {
try {
    delayedUrlTimer.ticking = false;
    delayedUrlTimer = null;
    url.clear();
    var restaurantInfoXml = url.fetch(nextUrlString);
    var parser = new DOMImplementation();
    var restaurantInfoDoc = parser.loadXML(restaurantInfoXml);

    buildRatingTable(restaurantInfoDoc);

    buildInfoTable(restaurantInfoDoc);

    // Set the top and height of the detail area

    commentsFrame.vOffset = horizRule.vOffset + 8;
    commentsFrame.height = (TEXT_AREA_BOTTOM - commentsFrame.vOffset);
    commentsFrame.opacity = 255;
    commentsScrollbar.opacity = 255;
    commentsScrollbar.vOffset = commentsFrame.vOffset;
    commentsScrollbar.height = commentsFrame.height;

    buildCommentsTable(restaurantInfoDoc);

} catch (err) {
}

hideWait();
}

function buildRatingTable(restaurantInfoDoc) {
    var restaurantNode = restaurantInfoDoc.getElementsByTagName("restaurant").item(0);
    var restaurantId = restaurantNode.getAttribute("id");

    numRatings.data = restaurantInfoDoc.getElementsByTagName("numRatings").item(0).firstChild.nodeValue;
    avgRating.data = restaurantInfoDoc.getElementsByTagName("avgRating").item(0).firstChild.nodeValue;
    smileyImage.src = "Resources/" + restaurantInfoDoc.getElementsByTagName("smileyUrl").item(0).firstChild.nodeValue;
    rateThisLink.onMouseUp = "openURL('" + BASE_URL + ADD_RATING_JSP + "?tcvid=" + restaurantId + "');";

    ratingTableBkg.opacity = 255;
    numRatingsLabel.opacity = 255;
    numRatings.opacity = 255;
    avgRatingLabel.opacity = 255;
    avgRating.opacity = 255;
    smileyImage.opacity = 255;
    rateThisLink.opacity = 255;
}

function createInfoLabel(theText, vOffset) {
    var textNode;

    textNode = new Text();
    textNode.window = mainWindow;
    textNode.data = theText;
    textNode.vOffset = vOffset;
    textNode.hOffset = MID_INFO_HOFFSET;
    textNode.alignment = "right";
    textNode.color = "#000000";
    textNode.font = "Verdana, Arial, Helvetica, Sans";
    textNode.size = 10;
    textNode.style = "bold";
    textNode.opacity = 255;

    return textNode;
}

function createInfoValue(theText, vOffset) {
    var textNode;

    textNode = new Text();
    textNode.window = mainWindow;
    textNode.data = theText;
    textNode.vOffset = vOffset;
    textNode.hOffset = MID_INFO_HOFFSET + 5;
    textNode.width = 150;
    textNode.alignment = "left";
    textNode.color = "#000000";
    textNode.font = "Verdana, Arial, Helvetica, Sans";
    textNode.size = 10;
    textNode.scrolling = "autoLeft";
    textNode.opacity = 255;

    return textNode;
}

function buildInfoTable(restaurantInfoDoc) {
    var idx;
    var elementList;
    var element;
    var cuisineIdx = 0;

    clearRestaurantInfo(false);

    var cuisineText = getNodeText(restaurantInfoDoc, "cuisine");

    var nextRowVOff = avgRatingLabel.vOffset + 22;

    if (cuisineText != null) {
        infoLabels[0] = createInfoLabel("Cuisine:", nextRowVOff);
        infoValues[0] = createInfoValue(cuisineText, nextRowVOff);
        nextRowVOff += ROW_HEIGHT;
        cuisineIdx++;
    }

    elementList = restaurantInfoDoc.getElementsByTagName("info");

    for (idx = 0; idx < elementList.length; idx++) {
        element = elementList.item(idx);
        var nameText  = element.getElementsByTagName("name").item(0).firstChild.nodeValue;
        var valueNode = element.getElementsByTagName("value").item(0).firstChild;

        if (valueNode != null) {
            var valueText = valueNode.nodeValue;

            infoLabels[idx + cuisineIdx] = createInfoLabel(nameText + ":", nextRowVOff);
            infoValues[idx + cuisineIdx] = createInfoValue(valueText, nextRowVOff);
            nextRowVOff += ROW_HEIGHT;
        }
    }

    var websiteUrl = getNodeText(restaurantInfoDoc, "website");

    if (websiteUrl != null) {
        websiteUrlNode.data = websiteUrl;
        websiteUrlNode.vOffset = nextRowVOff;
        websiteUrlNode.onMouseUp = "openURL('" + websiteUrl + "')";

        if (websiteUrlNode.width > 260) {
            websiteUrlNode.width = 260;
        }
        websiteUrlNode.opacity = 255;

        nextRowVOff += ROW_HEIGHT;
    }

    horizRule.vOffset = nextRowVOff - 8;
    horizRule.opacity = 255;
}

function buildCommentsTable(restaurantInfoDoc) {
    var elementList;
    var element;
    var comments = new String();

    commentsArea.data = "";

    elementList = restaurantInfoDoc.getElementsByTagName("rating");

    for (idx = 0; idx < elementList.length; idx++) {
        element = elementList.item(idx);
        var ratingNode = element.getElementsByTagName("ratingText").item(0).firstChild;

        if (ratingNode != null) {
            var ratingText = ratingNode.nodeValue;

            if (idx > 0) {
                comments += "\n----------------------------------------\n";
            }

            //if ((idx % 2) == 1) {
            //    row.setAttribute("bgcolor", "#bdd78f");
            //}

            var ratingCatVals = element.getElementsByTagName("ratingCatValue");

            for (jdx = 0; jdx < ratingCatVals.length; jdx++) {
                ratingVal = ratingCatVals.item(jdx).firstChild.nodeValue;

                comments += (RATINGS_CAT_LABELS[jdx] + ":" + ratingVal + "   ");
            }

            var dateNode = element.getElementsByTagName("date");
            if (dateNode != null) {
                var rcDate = dateNode.item(0).firstChild;
                if (rcDate != null) {
                    comments += rcDate.nodeValue;
                }
            }

            comments += "\n";
            comments += ratingText.replace(htmlBrRegex, "\n");
        }
    }

    commentsArea.data = comments;
    commentsArea.select(0, 0);
}

function showWait() {
    pleaseWait.opacity = 255;
}

function hideWait() {
    pleaseWait.opacity = 0;
}

function helpWrapUrlString(str) {
    var start = Math.floor(str.length / 2);

    for (var idx = start; idx < str.length; idx++) {
        if (str.charAt(idx) == "/") {
            return str.substring(0, idx+1) + " " + str.substr(idx+1);
        }
    }
    return str;
}

// Get the text for the node of the specified name. This function handles
// all the intermediate checking for null things and returns a null if any
// of them are null.
function getNodeText(xmlDoc, nodeName) {
    var theTag = xmlDoc.getElementsByTagName(nodeName);

    if (theTag == null) {
        return null;
    } else {
        var theNode = theTag.item(0);
        if (theNode == null) {
            return null;
        } else {
            return theNode.firstChild.nodeValue;
        }
    }
}
